"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CancerInterpretationRequest(ProtocolElement):
    """
    This record represents basic information for this report
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "analysisUri",
        "analysisVersion",
        "bams",
        "bigWigs",
        "cancerParticipant",
        "internalStudyId",
        "reportRequestId",
        "reportVersion",
        "structuralTieredVariants",
        "tieredVariants",
        "tieringVersion",
        "vcfs",
        "versionControl",
        "workspace",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "annotationFile": reports_4_2_0.File,
            "bams": reports_4_2_0.File,
            "bigWigs": reports_4_2_0.File,
            "cancerParticipant": participant_1_0_3.CancerParticipant,
            "otherFiles": reports_4_2_0.File,
            "structuralTieredVariants": reports_4_2_0.ReportedStructuralVariantCancer,
            "tieredVariants": reports_4_2_0.ReportedVariantCancer,
            "vcfs": reports_4_2_0.File,
            "versionControl": reports_4_2_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import participant as participant_1_0_3
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.participant.avro.CancerParticipant": participant_1_0_3.CancerParticipant,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.ReportedStructuralVariantCancer": reports_4_2_0.ReportedStructuralVariantCancer,
            "org.gel.models.report.avro.ReportedVariantCancer": reports_4_2_0.ReportedVariantCancer,
            "org.gel.models.report.avro.File": reports_4_2_0.File,
            "org.gel.models.report.avro.ReportVersionControl": reports_4_2_0.ReportVersionControl,
            "org.gel.models.report.avro.CancerInterpretationRequest": reports_4_2_0.CancerInterpretationRequest,
        }

    __slots__ = [
        "analysisUri",
        "analysisVersion",
        "bams",
        "bigWigs",
        "cancerParticipant",
        "internalStudyId",
        "reportRequestId",
        "reportVersion",
        "structuralTieredVariants",
        "tieredVariants",
        "tieringVersion",
        "vcfs",
        "versionControl",
        "workspace",
        "additionalInfo",
        "annotationFile",
        "interpretGenome",
        "otherFiles",
    ]

    def __init__(
        self,
        analysisUri,
        analysisVersion,
        bams,
        bigWigs,
        cancerParticipant,
        internalStudyId,
        reportRequestId,
        reportVersion,
        structuralTieredVariants,
        tieredVariants,
        tieringVersion,
        vcfs,
        versionControl,
        workspace,
        additionalInfo=None,
        annotationFile=None,
        interpretGenome=False,
        otherFiles=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.CancerInterpretationRequest model.

        :param analysisUri:
            Location (URI) where the data can be found
        :type analysisUri: str
        :param analysisVersion:
            GEL's analysis version for this request. It can increase if a change
            is made to the underlying data for example
        :type analysisVersion: str
        :param bams:
            BAMs Files
        :type bams: list[File]
        :param bigWigs:
            BigWig Files
        :type bigWigs: list[File]
        :param cancerParticipant:
        :type cancerParticipant: CancerParticipant
        :param internalStudyId:
            Internal Study id
        :type internalStudyId: str
        :param reportRequestId:
            Unique id for this report
        :type reportRequestId: str
        :param reportVersion:
            Version of this report
        :type reportVersion: int
        :param structuralTieredVariants:
            Structural Tiered Variants
        :type structuralTieredVariants: list[ReportedStructuralVariantCancer]
        :param tieredVariants:
            Tiered Variants
        :type tieredVariants: list[ReportedVariantCancer]
        :param tieringVersion:
            Tiering Version
        :type tieringVersion: str
        :param vcfs:
            VCFs Files where SVs and CNVs are represented
        :type vcfs: list[File]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param workspace:
            The genome shall be assigned to the workspaces(projects or domains
            with a predefined set of users) to control user access
        :type workspace: list[str]
        :param additionalInfo:
            Additional information
        :type additionalInfo: None | dict[str, str]
        :param annotationFile:
            This will be the output file from Cellbase + version used
        :type annotationFile: None | File
        :param interpretGenome:
            Simply load data to system or also provide interpretation?
        :type interpretGenome: boolean
        :param otherFiles:
            Other files that may be vendor specific         map of key: type of
            file, value: record of type File
        :type otherFiles: None | dict[str, File]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
